/**
 * \file
 *
 * \author Mattia Basaglia
 *
 * \copyright Copyright (C) 2017 Mattia Basaglia
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "all.hpp"
#include "input/input.hpp"

namespace scripting{
namespace namespaces{

using namespace boost::python;
using namespace input;

void scancode()
{
    enum_<ScanCode>("ScanCode")
        .value("UNKNOWN", ScanCode::UNKNOWN)
        .value("A", ScanCode::A)
        .value("B", ScanCode::B)
        .value("C", ScanCode::C)
        .value("D", ScanCode::D)
        .value("E", ScanCode::E)
        .value("F", ScanCode::F)
        .value("G", ScanCode::G)
        .value("H", ScanCode::H)
        .value("I", ScanCode::I)
        .value("J", ScanCode::J)
        .value("K", ScanCode::K)
        .value("L", ScanCode::L)
        .value("M", ScanCode::M)
        .value("N", ScanCode::N)
        .value("O", ScanCode::O)
        .value("P", ScanCode::P)
        .value("Q", ScanCode::Q)
        .value("R", ScanCode::R)
        .value("S", ScanCode::S)
        .value("T", ScanCode::T)
        .value("U", ScanCode::U)
        .value("V", ScanCode::V)
        .value("W", ScanCode::W)
        .value("X", ScanCode::X)
        .value("Y", ScanCode::Y)
        .value("Z", ScanCode::Z)
        .value("NUMBER_1", ScanCode::NUMBER_1)
        .value("NUMBER_2", ScanCode::NUMBER_2)
        .value("NUMBER_3", ScanCode::NUMBER_3)
        .value("NUMBER_4", ScanCode::NUMBER_4)
        .value("NUMBER_5", ScanCode::NUMBER_5)
        .value("NUMBER_6", ScanCode::NUMBER_6)
        .value("NUMBER_7", ScanCode::NUMBER_7)
        .value("NUMBER_8", ScanCode::NUMBER_8)
        .value("NUMBER_9", ScanCode::NUMBER_9)
        .value("NUMBER_0", ScanCode::NUMBER_0)
        .value("RETURN", ScanCode::RETURN)
        .value("ESCAPE", ScanCode::ESCAPE)
        .value("BACKSPACE", ScanCode::BACKSPACE)
        .value("TAB", ScanCode::TAB)
        .value("SPACE", ScanCode::SPACE)
        .value("MINUS", ScanCode::MINUS)
        .value("EQUALS", ScanCode::EQUALS)
        .value("LEFTBRACKET", ScanCode::LEFTBRACKET)
        .value("RIGHTBRACKET", ScanCode::RIGHTBRACKET)
        .value("BACKSLASH", ScanCode::BACKSLASH)
        .value("NONUSHASH", ScanCode::NONUSHASH)
        .value("SEMICOLON", ScanCode::SEMICOLON)
        .value("APOSTROPHE", ScanCode::APOSTROPHE)
        .value("GRAVE", ScanCode::GRAVE)
        .value("COMMA", ScanCode::COMMA)
        .value("PERIOD", ScanCode::PERIOD)
        .value("SLASH", ScanCode::SLASH)
        .value("CAPSLOCK", ScanCode::CAPSLOCK)
        .value("F1", ScanCode::F1)
        .value("F2", ScanCode::F2)
        .value("F3", ScanCode::F3)
        .value("F4", ScanCode::F4)
        .value("F5", ScanCode::F5)
        .value("F6", ScanCode::F6)
        .value("F7", ScanCode::F7)
        .value("F8", ScanCode::F8)
        .value("F9", ScanCode::F9)
        .value("F10", ScanCode::F10)
        .value("F11", ScanCode::F11)
        .value("F12", ScanCode::F12)
        .value("PRINTSCREEN", ScanCode::PRINTSCREEN)
        .value("SCROLLLOCK", ScanCode::SCROLLLOCK)
        .value("PAUSE", ScanCode::PAUSE)
        .value("INSERT", ScanCode::INSERT)
        .value("HOME", ScanCode::HOME)
        .value("PAGEUP", ScanCode::PAGEUP)
        .value("DELETE", ScanCode::DELETE)
        .value("END", ScanCode::END)
        .value("PAGEDOWN", ScanCode::PAGEDOWN)
        .value("RIGHT", ScanCode::RIGHT)
        .value("LEFT", ScanCode::LEFT)
        .value("DOWN", ScanCode::DOWN)
        .value("UP", ScanCode::UP)
        .value("NUMLOCKCLEAR", ScanCode::NUMLOCKCLEAR)
        .value("KP_DIVIDE", ScanCode::KP_DIVIDE)
        .value("KP_MULTIPLY", ScanCode::KP_MULTIPLY)
        .value("KP_MINUS", ScanCode::KP_MINUS)
        .value("KP_PLUS", ScanCode::KP_PLUS)
        .value("KP_ENTER", ScanCode::KP_ENTER)
        .value("KP_1", ScanCode::KP_1)
        .value("KP_2", ScanCode::KP_2)
        .value("KP_3", ScanCode::KP_3)
        .value("KP_4", ScanCode::KP_4)
        .value("KP_5", ScanCode::KP_5)
        .value("KP_6", ScanCode::KP_6)
        .value("KP_7", ScanCode::KP_7)
        .value("KP_8", ScanCode::KP_8)
        .value("KP_9", ScanCode::KP_9)
        .value("KP_0", ScanCode::KP_0)
        .value("KP_PERIOD", ScanCode::KP_PERIOD)
        .value("NONUSBACKSLASH", ScanCode::NONUSBACKSLASH)
        .value("APPLICATION", ScanCode::APPLICATION)
        .value("POWER", ScanCode::POWER)
        .value("KP_EQUALS", ScanCode::KP_EQUALS)
        .value("F13", ScanCode::F13)
        .value("F14", ScanCode::F14)
        .value("F15", ScanCode::F15)
        .value("F16", ScanCode::F16)
        .value("F17", ScanCode::F17)
        .value("F18", ScanCode::F18)
        .value("F19", ScanCode::F19)
        .value("F20", ScanCode::F20)
        .value("F21", ScanCode::F21)
        .value("F22", ScanCode::F22)
        .value("F23", ScanCode::F23)
        .value("F24", ScanCode::F24)
        .value("EXECUTE", ScanCode::EXECUTE)
        .value("HELP", ScanCode::HELP)
        .value("MENU", ScanCode::MENU)
        .value("SELECT", ScanCode::SELECT)
        .value("STOP", ScanCode::STOP)
        .value("AGAIN", ScanCode::AGAIN)
        .value("UNDO", ScanCode::UNDO)
        .value("CUT", ScanCode::CUT)
        .value("COPY", ScanCode::COPY)
        .value("PASTE", ScanCode::PASTE)
        .value("FIND", ScanCode::FIND)
        .value("MUTE", ScanCode::MUTE)
        .value("VOLUMEUP", ScanCode::VOLUMEUP)
        .value("VOLUMEDOWN", ScanCode::VOLUMEDOWN)
        .value("KP_COMMA", ScanCode::KP_COMMA)
        .value("KP_EQUALSAS400", ScanCode::KP_EQUALSAS400)
        .value("INTERNATIONAL1", ScanCode::INTERNATIONAL1)
        .value("INTERNATIONAL2", ScanCode::INTERNATIONAL2)
        .value("INTERNATIONAL3", ScanCode::INTERNATIONAL3)
        .value("INTERNATIONAL4", ScanCode::INTERNATIONAL4)
        .value("INTERNATIONAL5", ScanCode::INTERNATIONAL5)
        .value("INTERNATIONAL6", ScanCode::INTERNATIONAL6)
        .value("INTERNATIONAL7", ScanCode::INTERNATIONAL7)
        .value("INTERNATIONAL8", ScanCode::INTERNATIONAL8)
        .value("INTERNATIONAL9", ScanCode::INTERNATIONAL9)
        .value("LANG1", ScanCode::LANG1)
        .value("LANG2", ScanCode::LANG2)
        .value("LANG3", ScanCode::LANG3)
        .value("LANG4", ScanCode::LANG4)
        .value("LANG5", ScanCode::LANG5)
        .value("LANG6", ScanCode::LANG6)
        .value("LANG7", ScanCode::LANG7)
        .value("LANG8", ScanCode::LANG8)
        .value("LANG9", ScanCode::LANG9)
        .value("ALTERASE", ScanCode::ALTERASE)
        .value("SYSREQ", ScanCode::SYSREQ)
        .value("CANCEL", ScanCode::CANCEL)
        .value("CLEAR", ScanCode::CLEAR)
        .value("PRIOR", ScanCode::PRIOR)
        .value("RETURN2", ScanCode::RETURN2)
        .value("SEPARATOR", ScanCode::SEPARATOR)
        .value("OUT", ScanCode::OUT)
        .value("OPER", ScanCode::OPER)
        .value("CLEARAGAIN", ScanCode::CLEARAGAIN)
        .value("CRSEL", ScanCode::CRSEL)
        .value("EXSEL", ScanCode::EXSEL)
        .value("KP_00", ScanCode::KP_00)
        .value("KP_000", ScanCode::KP_000)
        .value("THOUSANDSSEPARATOR", ScanCode::THOUSANDSSEPARATOR)
        .value("DECIMALSEPARATOR", ScanCode::DECIMALSEPARATOR)
        .value("CURRENCYUNIT", ScanCode::CURRENCYUNIT)
        .value("CURRENCYSUBUNIT", ScanCode::CURRENCYSUBUNIT)
        .value("KP_LEFTPAREN", ScanCode::KP_LEFTPAREN)
        .value("KP_RIGHTPAREN", ScanCode::KP_RIGHTPAREN)
        .value("KP_LEFTBRACE", ScanCode::KP_LEFTBRACE)
        .value("KP_RIGHTBRACE", ScanCode::KP_RIGHTBRACE)
        .value("KP_TAB", ScanCode::KP_TAB)
        .value("KP_BACKSPACE", ScanCode::KP_BACKSPACE)
        .value("KP_A", ScanCode::KP_A)
        .value("KP_B", ScanCode::KP_B)
        .value("KP_C", ScanCode::KP_C)
        .value("KP_D", ScanCode::KP_D)
        .value("KP_E", ScanCode::KP_E)
        .value("KP_F", ScanCode::KP_F)
        .value("KP_XOR", ScanCode::KP_XOR)
        .value("KP_POWER", ScanCode::KP_POWER)
        .value("KP_PERCENT", ScanCode::KP_PERCENT)
        .value("KP_LESS", ScanCode::KP_LESS)
        .value("KP_GREATER", ScanCode::KP_GREATER)
        .value("KP_AMPERSAND", ScanCode::KP_AMPERSAND)
        .value("KP_DBLAMPERSAND", ScanCode::KP_DBLAMPERSAND)
        .value("KP_VERTICALBAR", ScanCode::KP_VERTICALBAR)
        .value("KP_DBLVERTICALBAR", ScanCode::KP_DBLVERTICALBAR)
        .value("KP_COLON", ScanCode::KP_COLON)
        .value("KP_HASH", ScanCode::KP_HASH)
        .value("KP_SPACE", ScanCode::KP_SPACE)
        .value("KP_AT", ScanCode::KP_AT)
        .value("KP_EXCLAM", ScanCode::KP_EXCLAM)
        .value("KP_MEMSTORE", ScanCode::KP_MEMSTORE)
        .value("KP_MEMRECALL", ScanCode::KP_MEMRECALL)
        .value("KP_MEMCLEAR", ScanCode::KP_MEMCLEAR)
        .value("KP_MEMADD", ScanCode::KP_MEMADD)
        .value("KP_MEMSUBTRACT", ScanCode::KP_MEMSUBTRACT)
        .value("KP_MEMMULTIPLY", ScanCode::KP_MEMMULTIPLY)
        .value("KP_MEMDIVIDE", ScanCode::KP_MEMDIVIDE)
        .value("KP_PLUSMINUS", ScanCode::KP_PLUSMINUS)
        .value("KP_CLEAR", ScanCode::KP_CLEAR)
        .value("KP_CLEARENTRY", ScanCode::KP_CLEARENTRY)
        .value("KP_BINARY", ScanCode::KP_BINARY)
        .value("KP_OCTAL", ScanCode::KP_OCTAL)
        .value("KP_DECIMAL", ScanCode::KP_DECIMAL)
        .value("KP_HEXADECIMAL", ScanCode::KP_HEXADECIMAL)
        .value("LCTRL", ScanCode::LCTRL)
        .value("LSHIFT", ScanCode::LSHIFT)
        .value("LALT", ScanCode::LALT)
        .value("LGUI", ScanCode::LGUI)
        .value("RCTRL", ScanCode::RCTRL)
        .value("RSHIFT", ScanCode::RSHIFT)
        .value("RALT", ScanCode::RALT)
        .value("RGUI", ScanCode::RGUI)
        .value("MODE", ScanCode::MODE)
        .value("AUDIONEXT", ScanCode::AUDIONEXT)
        .value("AUDIOPREV", ScanCode::AUDIOPREV)
        .value("AUDIOSTOP", ScanCode::AUDIOSTOP)
        .value("AUDIOPLAY", ScanCode::AUDIOPLAY)
        .value("AUDIOMUTE", ScanCode::AUDIOMUTE)
        .value("MEDIASELECT", ScanCode::MEDIASELECT)
        .value("WWW", ScanCode::WWW)
        .value("MAIL", ScanCode::MAIL)
        .value("CALCULATOR", ScanCode::CALCULATOR)
        .value("COMPUTER", ScanCode::COMPUTER)
        .value("AC_SEARCH", ScanCode::AC_SEARCH)
        .value("AC_HOME", ScanCode::AC_HOME)
        .value("AC_BACK", ScanCode::AC_BACK)
        .value("AC_FORWARD", ScanCode::AC_FORWARD)
        .value("AC_STOP", ScanCode::AC_STOP)
        .value("AC_REFRESH", ScanCode::AC_REFRESH)
        .value("AC_BOOKMARKS", ScanCode::AC_BOOKMARKS)
        .value("BRIGHTNESSDOWN", ScanCode::BRIGHTNESSDOWN)
        .value("BRIGHTNESSUP", ScanCode::BRIGHTNESSUP)
        .value("DISPLAYSWITCH", ScanCode::DISPLAYSWITCH)
        .value("KBDILLUMTOGGLE", ScanCode::KBDILLUMTOGGLE)
        .value("KBDILLUMDOWN", ScanCode::KBDILLUMDOWN)
        .value("KBDILLUMUP", ScanCode::KBDILLUMUP)
        .value("EJECT", ScanCode::EJECT)
        .value("SLEEP", ScanCode::SLEEP)
        .value("APP1", ScanCode::APP1)
        .value("APP2", ScanCode::APP2)
    ;
}


void melanoengine_input(scope& parent)
{
    scope module_graphics(make_submodule(parent, "input"));

    auto WrappedMouseStatus = class_<MouseStatus>("MouseStatus")
        .def_readwrite("pos", &MouseStatus::pos)
        .def_readwrite("buttons", &MouseStatus::buttons)
    ;
    WrappedMouseStatus.attr("NoButton") = MouseStatus::MouseButtons(MouseStatus::NoButton);
    WrappedMouseStatus.attr("LeftButton") = MouseStatus::MouseButtons(MouseStatus::LeftButton);
    WrappedMouseStatus.attr("MiddleButton") = MouseStatus::MouseButtons(MouseStatus::MiddleButton);
    WrappedMouseStatus.attr("RightButton") = MouseStatus::MouseButtons(MouseStatus::RightButton);
    WrappedMouseStatus.attr("X1Button") = MouseStatus::MouseButtons(MouseStatus::X1Button);
    WrappedMouseStatus.attr("X2Button") = MouseStatus::MouseButtons(MouseStatus::X2Button);

    class_<Input, boost::noncopyable>("Input")
        .def("mouse_status", &Input::mouse_status, arg("global")=false)
        .def("keyboard_status", &Input::keyboard_status)
    ;

    scancode();

    class_<Key, boost::noncopyable>("Key", no_init)
        .def(init<KeyValue>())
        .def(init<ScanCode>())
        .def(init<const std::string&>())
        .def("name", &Key::name)
        .def("value", &Key::value)
        .def("code", &Key::code)
        .def("is_down", &Key::is_down)
        .def("__repr__", [](const Key& key){
            return"<Key " + key.name() + " " + std::to_string(uint16_t(key.code())) +">";
        })
    ;

    class_<KeyboardStatus>("KeyboardStatus", no_init)
        .def("is_down", (bool (KeyboardStatus::*)(const Key&) const)&KeyboardStatus::is_down)
        .def("is_down", (bool (KeyboardStatus::*)(ScanCode) const)&KeyboardStatus::is_down)
    ;
}

} // namespace namespaces
} // namespace scripting
